<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Cus01700CustoRealizadoGlobalDoPeriodo extends \Zeedhi\Framework\Controller\Report {

    protected $qr2Strategy;
    protected $environment;
    protected $crudService;
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $qr2Strategy, $environment, $crudService, $birtStrategy) {
        $this->qr2Strategy  = $qr2Strategy;
        $this->environment  = $environment;
        $this->crudService  = $crudService;
        parent::__construct($reportService);
        $this->birtStrategy = $birtStrategy;
    }
    
    protected $reportMapping = array (
        'CUS01700' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01701' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01702' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01703' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01704' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01705' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01706' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01707' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01708' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS01709' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS0170A' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'
            )
        ),
        'CUS0170B' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'          => 'P_CDFILIAL',
                'CDSERVFILI'        => 'P_CDSERVFILI',
                'DTINICIAL'         => 'P_DTINICIAL',
                'DTFINAL'           => 'P_DTFINAL',
                'CDARVPRODINICIAL'  => 'P_CDPRODUTOINI',
                'CDARVPRODFINAL'    => 'P_CDPRODUTOFIN',
                'DTMESINIC'         => 'P_DTMESINIC',
                'DTMESFINA'         => 'P_DTMESFINA',
                'NMTIPOCUSTO'       => 'P_NMCUSTO',
                'CDTIPOCUSTO'       => 'P_NRTIPOCUSTO',
                'NRTAMCODIGO'       => 'P_NRTAMCODIGO',
                'NRTAMACNIVEL'      => 'P_NRTAMACNIVEL',   
                'IDESTOCAVEL'       => 'P_IDESTOCAVEIS',
                'IDNAOESTOC'        => 'P_IDNESTOCAVEIS',
                'DTPERIINIC'        => 'P_DTPERIINIC',
                'DTPERIFINA'        => 'P_DTPERIFINA',
                'NRORG'             => 'P_NRORG'

            )
        )
        
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        if($row['ALLSERVFILI'] == 'S') $row['CDSERVFILI'] = $this->getServicos($row);
        else $row['CDSERVFILI'] = implode('_',$row['NMSERVICO']);
        
        if($row['CDSERVFILI'] == '') {
            $row['CDSERVFILI'] = 0;
        }
        $tamanho = 10;
        $completaCom = 'z';
        $row['CDARVPRODFINAL'] = str_pad($row['CDARVPRODFINAL'], 10, 'z', STR_PAD_RIGHT);
        
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }
    
    private function getServicos($row){
        $cdgrupserv = $row['ALLGRUPSERV'] == 'S'? 'T' : implode('_', $row['NMGRUPSERV']);

        $dataSourceName = 'servicos_por_grupo';
        
        $conditions = array(
            array(
                "columnName" => "CDFILIAL",
                "operator"   => '=',
                "value"      => $row['CDFILIAL']
            ),
            array(
                "columnName" => "CDGRUPSERV",
                "operator"   => '=',
                "value"      => $cdgrupserv
            ),
            array(
                "columnName" => "CDOPERADOR",
                "operator"   => '=',
                "value"      => $row['CDOPERADOR']
            ),
            array(
                "columnName" => "NRORG",
                "operator"   => '=',
                "value"      => $row['NRORG']
            )
        );
        $dataSet = $this->crudService->getFilteredDataSet($dataSourceName, $conditions);
        $servicos = $dataSet->getRows();

        $concatServ = '';
        foreach ($servicos as $serv) {
            $concatServ .= $serv['CDSERVFILI'].'_';
        }
        return $concatServ;

    }
}