<?php
namespace Teknisa\CUS\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Cus01900CustoDaUnidadeDeRefeicao extends \Zeedhi\Framework\Controller\Report {
  protected $novoCodigo;
  protected $consplan;
  protected $servicoPorGrupo;
  protected $nrorg;
  protected $cdfilial;
  protected $nrConsPlan;
  protected $birtStrategy;
  protected $Listas;
  protected $environment;
  protected $connection;

  public function __construct($reportService, $novoCodigo, $consplan, $servicoPorGrupo, $birtStrategy, $Listas, $environment, $util, StoredProcedure $procedureConsplanGeral, $connection) {
    $this->novoCodigo                 = $novoCodigo;
    $this->consplan                   = $consplan;
    $this->servicoPorGrupo            = $servicoPorGrupo;
    $this->reportService              = $reportService;
    $this->birtStrategy               = $birtStrategy;
    $this->Listas                     = $Listas;
    $this->environment                = $environment;
    $this->util                       = $util;
    $this->procedureConsplanGeral     = $procedureConsplanGeral;
    $this->connection                 = $connection;
  }   
  
  protected $reportMapping = array(
      'CUS01900' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "NRORG"  => "P_NRORG",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "DTINICIAL"  => "P_STDATAINIC",
        "DTFINAL"  =>  "P_STDATAFINA",
        "CDFILIAL" => "P_CDFILIAL",
        "DATAINIC"  =>  "P_DATAINIC",
        "DATAFINA"  =>  "P_DATAFINA",
        "LISTASERV"  =>  "P_CDSERVFILI",
        "CDTIPOCUSTO"  =>  "P_NRTIPOCUSTO",
        "CDGRUPPROD"  =>  "P_CDGRUPPROD"
      )
    ),
      'CUS01901' => 
    array (
      'strategy' => 'BIRT',
      'parameterMapping' => 
      array (
        "NRORG"  => "P_NRORG",
        "NMTIPOCUSTO"  => "P_NMCUSTO",
        "DTINICIAL"  => "P_STDATAINIC",
        "DTFINAL"  =>  "P_STDATAFINA",
        "CDFILIAL" => "P_CDFILIAL",
        "DATAINIC"  =>  "P_DATAINIC",
        "DATAFINA"  =>  "P_DATAFINA",
        "LISTASERV"  =>  "P_CDSERVFILI",
        "CDTIPOCUSTO"  =>  "P_NRTIPOCUSTO",
        "CDGRUPPROD"  =>  "P_CDGRUPPROD"
      )
    )   
      ); 
      
    public function createRemoteReport(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $this->beforeProcessReport($request, $response);
            $reportURL = $this->processReport($request);
            $response->addMessage(new DTO\Response\Message($reportURL));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        } 
    }    
  
   public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
    $row['NRORG'] = $this->environment->getNrorg();
    $row['DATAINIC'] = $row['DTINICIAL']; 
    $row['DATAFINA'] = $row['DTFINAL'];
    $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    
    $cdoperador = $this->environment->getCdOperador();
    $cdfilial = $row['CDFILIAL'];
    $nrorg = $row['NRORG'];
    $cdgrupserv = $row['LISTAGRUPSERV'];


    if (($row['LISTASERV'] == 'REQUEST')) {
        $row['LISTASERV'] = $this->servicoPorGrupo->retornaServicosPorGrupo($nrorg, $cdfilial, $cdoperador, $cdgrupserv);
    }
  }
}